#!/usr/bin/env python
# -*- coding: utf-8 -*-

import re
import cgi
import string
from htmlentitydefs import *
from xml.sax.saxutils import escape


unichr2entity = dict((unichr(code), '&%s;' % name) for code, name in codepoint2name.iteritems() if code!=38) # exclude "&"
entity2unichr = dict(('&%s;' % name, unichr(code)) for name, code in name2codepoint.iteritems())

def htmlescape(text, d=unichr2entity):
	try:
		text=text.decode('utf-8')
	except:
		pass
	
	text=cgi.escape(text).encode('ascii', 'xmlcharrefreplace') 

	for key, value in d.iteritems():
		if key in text:
			text = text.replace(key, value)
	
	text = text.replace('&amp;', '&#38;')

	return text

def htmlunescape(text, d=entity2unichr):
	for key, value in d.iteritems():

		if key in text:
			text = text.replace(key, value.encode('utf-8'))

	return text
