<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/tables.inc.php');
	require_once(CI_PATH_LIBS.'/buttons.inc.php');
	require_once(CI_PATH_LIBS.'/fields.inc.php');

	CI_AUTH::require_auth('admin', array('reply' => 'html'));

	$buttons=new CI_BUTTONS();
	$buttons->add_button(array(
 		'name'	=> 'load',
 		'icon'	=> $CI_URI_BASE.'/icons/buttons/import.png',
 		'label'	=> ci_lbl("system.license.load")
 	));
?>
<script type="text/javascript">
	function on_button_event(id, task)
	{
		switch (task)
		{
			case 'load':	ci_load_page('system/license/load.php'); break;
		}
	}
</script>

<div class="title"><?php echo ci_lbl("system.license.title") ?></div>

<?php if (strlen($CI_CORE_CONFIG_LICENSE['serial'])) { ?>
<table class="table">
	<tr>
		<td class="table" style="width: 35%; font-weight: bold"><?php echo ci_lbl("system.license.serial") ?></td>
		<td class="table"><?php echo $CI_CORE_CONFIG_LICENSE['serial'] ?></td>
	</tr>
	<tr>
		<td class="table" style="font-weight: bold"><?php echo ci_lbl("system.license.owner-name") ?></td>
		<td class="table"><?php echo $CI_CORE_CONFIG_LICENSE['owner']['name'] ?></td>
	</tr>
	<tr>
		<td class="table" style="font-weight: bold"><?php echo ci_lbl("system.license.owner-email") ?></td>
		<td class="table"><?php echo $CI_CORE_CONFIG_LICENSE['owner']['email'] ?></td>
	</tr>
	<tr>
		<td class="table" style="font-weight: bold"><?php echo ci_lbl("system.license.maxcalls") ?></td>
		<td class="table"><?php echo $CI_CORE_CONFIG_LICENSE['maxcalls'] ?></td>
	</tr>
	<tr>
		<td class="table" style="font-weight: bold"><?php echo ci_lbl("system.license.maxclients") ?></td>
		<td class="table"><?php echo $CI_CORE_CONFIG_LICENSE['maxclients'] ?></td>
	</tr>
	<tr>
		<td class="table" style="font-weight: bold"><?php echo ci_lbl("system.license.version") ?></td>
		<td class="table"><?php echo substr($CI_CORE_CONFIG_LICENSE['version'], 0, 5) ?>.xx</td>
	</tr>
</table>
<?php } else { ?>
<div class="bignote"><?php echo ci_lbl("system.license.unregistered") ?></div>
<br />
<div class="text">
	<?php echo ci_lbl("system.license.unregistered-text", array('machinecode' => ci_license_get_mc())) ?>
</div>
<?php } ?>

<?php echo $buttons->get(); ?>
